## Calculate Tilt

###### DESCRIPTION (credit Leetcode.com)

Given the root node of a binary tree, write a recursive function to return the sum of each node's tilt.

The tilt of a node is the absolute difference between the sum of its left subtree and the sum of its right subtree. If a node has an empty left or subtree, the sum of the empty subtree is 0.

###### EXAMPLES

**Example 1**:

Input:

`[5, 1, 3]`

Output:

`2`

The leaf nodes 1, 3 have tilts of 0 (their left and right subtrees are empty)

The root node 5 has a tilt of |1 - 3| = 2

**Example 2**:

Input:

`[4, 2, 7, 1, 3, 6, 9]`

Output:

`21`

The leaf nodes 1, 3, 6, 9 have tilts of 0 (their left and right subtrees are empty)

Node 2 has a tilt of |1 - 3| = 2

Node 7 has a tilt of |6 - 9| = 3

Node 4 has a tilt of |6 - 22] = 16

2 + 3 + 16 = 21

Run your code to see results here

## Explanation

We can solve this problem using the framework established in the Overview section.

**Return Values**

If I'm at a node in the tree, what values do I need to calculate the tilt of the subtree rooted at that node?

- The sum of the values in the left subtree.
- The sum of the values in the right subtree.

This tells me that each recursive call should return the sum of the values in the subtree rooted at the current node. So in the body of the recursive function, I'll make recursive calls to the current node's left and right children, and then add the value of the current node to return the sum of the current subtree.

Before returning the sum of the current subtree, I'll also need to calculate the tilt of the current subtree. I can calculate the tilt of the current subtree as abs(left - right), and add that a global variable tilt that stores the total tilt of the tree. (see the **Global Variables** section for more details on why this is necessary).

# get the sum of current node's left and right subtreesleft = dfs(node.left)right = dfs(node.right)# calculate tilt of current subtree and add it to the global tilt variabletilt += abs(left - right)# return the sum of the current subtreereturn left + right + node.val

**Base Case**

The tilt of an empty tree is 0.

**Global Variables**
Note that the problem is asking for the total tilt of the tree, but each recursive call returns the sum of the nodes in the subtree rooted at a given node. Since these two values are different, we can use a global variable tilt to store the total tilt of the tree. This allows us to avoid using multiple return values in our recursive function, or having to pass the total tilt value from the parent to the child.

**Helper Function**

We don't need to pass values from the parent to the child to solve this problem. However, since we are using a global variable to store the total tilt of the tree, we should define tilt inside the body of our main function, and then introduce a helper function to perform the recursive calls. This way, no code outside of the main function will have access to the tilt variable.

Inside the main function, we can initiate the call to the helper function, passing in the root of the tree as an argument. We return the value of tilt after the recursive helper function has finished executing.

## Solution

class Solution:def findTilt(self, root: TreeNode) -> int:tilt = 0# define a helper function to perform the recursive calls# this ensures that the tilt variable is not accessible outside of the main functiondef dfs(node):nonlocal tilt# base caseif not node:return 0# get the sum of the current node's left and right subtreesleft = dfs(node.left)right = dfs(node.right)# calculate tilt of current subtree, and add it to the global tilt variabletilt += abs(left - right)# return the sum of the current subtreereturn left + right + node.val# initiate the call to the helper functiondfs(root)return tilt

## Complexity Analysis

**Time Complexity:** O(N), where N is the number of nodes in the tree. We visit each node exactly once, and at each node, we perform constant time work.

**Space Complexity:** O(N), where N is the number of nodes. A total of N call frames have to be allocated, one for each node in the tree.

Loading comments...